#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "xymms.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"


void
on_fileinfo_compress_button_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  GYMTAG info_gymtag;
  GtkWidget *widget = NULL;

  memset(&info_gymtag, 0, sizeof(GYMTAG));
  widget = lookup_widget(fileinfo_win, "compress_checkbox");
  if(read_gymtag(name, &info_gymtag))
    {
      if(! info_gymtag.compressed)
	{
	  if(! write_gym(name, &info_gymtag))
	    {
	      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), 1);
	      gtk_label_set_text(GTK_LABEL(compress_label), "Decompress");
	    }
	}
      else
	{
	  if(! write_gym(name, &info_gymtag))
	    {
	      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), 0);
	      gtk_label_set_text(GTK_LABEL(compress_label), "Compress");
	    }
	}
    }
}


void
on_fileinfo_ok_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  on_fileinfo_apply_button_clicked(button, user_data);
  gtk_widget_hide(GTK_WIDGET(fileinfo_win));
}


void
on_fileinfo_apply_button_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  FILE *file = NULL;
  GYMTAG changed;
  GtkWidget *widget = NULL;
  unsigned char *buf = NULL;
  int len = 0;
  int needs_update = 1; /* Temp */

  memset(&changed, 0, sizeof(GYMTAG));
  if(read_gymtag(name, &changed))
    {
      if(fileinfo_win && needs_update)
	{
	  changed.gym_id = ('G' + ('Y' << 8) + ('M' << 16) + ('X' << 24));
	  /*
	   * Yeah, I know it's a deprecated GtkEntry function.  :)
	   */
	  widget = lookup_widget(fileinfo_win, "songtitle_entry");
	  strncpy((char*)&changed.song_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "gametitle_entry");
	  strncpy((char*)&changed.game_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "gamepublisher_entry");
	  strncpy((char*)&changed.game_publisher, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "rippedwith_entry");
	  strncpy((char*)&changed.ripped_with, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "rippedby_entry");
	  strncpy((char*)&changed.ripped_by, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "comments_textbox");
	  strncpy((char*)&changed.comments, gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1), 256);
	}

      file = fopen(name, "r+");
      if(file)
	{
      	  rewind(file);
	  write_gymtag(name, &changed);
	  fclose(file);
	}
      else
	return;
    }
  else
    {
      if(fileinfo_win)
	{
	  changed.gym_id = ('G' + ('Y' << 8) + ('M' << 16) + ('X' << 24));
	  widget = lookup_widget(fileinfo_win, "songtitle_entry");
	  strncpy((char*)&changed.song_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "gametitle_entry");
	  strncpy((char*)&changed.game_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "gamepublisher_entry");
	  strncpy((char*)&changed.game_publisher, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "rippedwith_entry");
	  strncpy((char*)&changed.ripped_with, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "rippedby_entry");
	  strncpy((char*)&changed.ripped_by, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	  widget = lookup_widget(fileinfo_win, "comments_textbox");
	  strncpy((char*)&changed.comments, gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1), 256);
	}
      
      file = fopen(name, "r+");
      if(file)
	{
	  if(fileinfo_win && needs_update)
	    {
	      changed.gym_id = ('G' + ('Y' << 8) + ('M' << 16) + ('X' << 24));
	      widget = lookup_widget(fileinfo_win, "songtitle_entry");
	      strncpy((char*)&changed.song_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	      widget = lookup_widget(fileinfo_win, "gametitle_entry");
	      strncpy((char*)&changed.game_title, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	      widget = lookup_widget(fileinfo_win, "gamepublisher_entry");
	      strncpy((char*)&changed.game_publisher, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	      widget = lookup_widget(fileinfo_win, "rippedwith_entry");
	      strncpy((char*)&changed.ripped_with, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	      widget = lookup_widget(fileinfo_win, "rippedby_entry");
	      strncpy((char*)&changed.ripped_by, gtk_entry_get_text(GTK_ENTRY(widget)), 32);
	      widget = lookup_widget(fileinfo_win, "comments_textbox");
	      strncpy((char*)&changed.comments, gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1), 256);
	    }
	  rewind(file);
	  fseek(file, 0, SEEK_END);
	  len = ftell(file);
	  buf = (unsigned char*)malloc(len);
	  rewind(file);
	  fread(buf, len, 1, file);
	  fclose(file);
	  file = NULL;
	  if(! write_gymtag(name, &changed))
	      write_gymdata(name, buf, len);
	  if(buf)
	    free(buf);
	}
      else
	return;
    }
}


void
on_fileinfo_about_button_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  about();
}


void
on_configure_ok_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  ConfigFile *cfg = NULL;
  char *filename = NULL;
  GtkWidget *widget = NULL;

  on_configure_apply_button_clicked(button, user_data);

  filename = g_strconcat(g_get_home_dir(), "/.xmms/config", NULL);
  cfg = xmms_cfg_open_file(filename);
  if(!cfg)
    {
      cfg = xmms_cfg_new();
    }
  xmms_cfg_write_int(cfg, "XymMS", "samples_per_sec", ext_samples_per_sec);
  xmms_cfg_write_int(cfg, "XymMS", "channels", ext_channels);
  xmms_cfg_write_int(cfg, "XymMS", "bits_per_sample", ext_bits_per_sample);
  xmms_cfg_write_int(cfg, "XymMS", "ym2612_clock", ym2612_clock);
  xmms_cfg_write_int(cfg, "XymMS", "sn76496_clock", sn76496_clock);
  xmms_cfg_write_file(cfg, filename);
  xmms_cfg_free(cfg);
  free(filename);
  gtk_widget_hide(GTK_WIDGET(configure_win));
}


void
on_configure_apply_button_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *widget = NULL;
  GtkWidget *label = NULL;
  GtkWidget *menu = NULL;
  GtkWidget *item = NULL;
  GtkAdjustment *adj = NULL;
  char string[16];
  int index = -1;

  /* Get the sample rate from the option menu and set the global var. */
  widget = lookup_widget(GTK_WIDGET(configure_win), "sample_menu");
  if(widget)
    {
      menu = GTK_OPTION_MENU(widget)->menu;
      if(menu)
	{
	  item = gtk_menu_get_active(GTK_MENU(menu));
	  if(item)
	    {
	      index = g_list_index(GTK_MENU_SHELL(menu)->children, item);
	      if(index >= 0)
		{
		  ext_samples_per_sec = samples_menu[index];
		  index = -1;
		}
	      item = NULL;
	    }
	  menu = NULL;
	}
      widget = NULL;
    }

  /* Get the channels from the option menu and set the global var. */
  widget = lookup_widget(GTK_WIDGET(configure_win), "channel_menu");
  if(widget)
    {
      menu = GTK_OPTION_MENU(widget)->menu;
      if(menu)
	{
	  item = gtk_menu_get_active(GTK_MENU(menu));
	  if(item)
	    {
	      index = g_list_index(GTK_MENU_SHELL(menu)->children, item);
	      if(index >= 0)
		{
		  ext_channels = channels_menu[index];
		  index = -1;
		}
	      item = NULL;
	    }
	  menu = NULL;
	}
      widget = NULL;
    }

  /* Get the YM2612 clock speed from the slider and set the label and global var. */
  widget = lookup_widget(GTK_WIDGET(configure_win), "ym2612_scale");
  if(widget)
    {
      adj = gtk_range_get_adjustment(GTK_RANGE(widget));
      if(adj)
	{
	  ym2612_clock = adj->value;
	  label = lookup_widget(GTK_WIDGET(configure_win), "ym2612_label");
	  if(label)
	    {
	      memset(string, 0, 16);
	      sprintf(string, "%d", (int)(ym2612_clock * ym2612_base / 100));
	      gtk_label_set_text(GTK_LABEL(label), string);
	      label = NULL;
	    }
	  adj = NULL;
	}
      widget = NULL;
    }

  /* Get the SN76946 clock speed from the slider and set the label and global var. */
  widget = lookup_widget(GTK_WIDGET(configure_win), "sn76496_scale");
  if(widget)
    {
      adj = gtk_range_get_adjustment(GTK_RANGE(widget));
      if(adj)
	{
	  sn76496_clock = adj->value;
	  label = lookup_widget(GTK_WIDGET(configure_win), "sn76496_label");
	  if(label)
	    {
	      memset(string, 0, 16);
	      sprintf(string, "%d", (int)(sn76496_clock * sn76496_base / 100));
	      gtk_label_set_text(GTK_LABEL(label), string);
	      label = NULL;
	    }
	  adj = NULL;
	}
      widget = NULL;
    }
}

